from  kernel_parameter import *
from parse_digit import *
from os import system
methodlist = ['l1-loss','l2-loss']
cv_data = ['iris','wine','glass','vowel','vehicle','segment']
data = ['dna','satimage','letter','shuttle']
print """
\\begin{tabular}{@{}l|rrr|rrr@{}}
  & \\multicolumn{3}{c|}{L1 loss} & \\multicolumn{3}{c}{L2 loss} \\\\
  &training& test or CV & &training & test or CV\\\\
  data set & time & accuracy &nSV&time & accuracy & nSV\\\\
	\\hline
"""		
for d in cv_data:
	o = []
	for method in methodlist:
		dp = log_path + d + '.' + method + '.log'
		try:
			tmp_data = open(dp,'r').readlines()
		except:
			traindata = path + data_path[d]
			if method == "l1-loss":
				cmd = "%s -c %s -g %s -v 10 -m 2048 -s 2 -t 2 %s >> %s"%(bsvm_train_exe, best_l1_c[d],best_l1_g[d],traindata,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "l2-loss":
				cmd = "%s -c %s -g %s -v 10 -m 2048 -s 4 -t 2 %s >> %s"%(bsvm_train_exe, best_l2_c[d],best_l2_g[d],traindata,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			tmp_data = open(dp,'r').readlines()
		
		for l in tmp_data:
			if 'Cross Validation Total Training Time' in l:
				time = l.split(' ')[-1].strip()
				digit = FormatWithCommas("%5.2f",float(time))
				o.append(digit)
			if 'Cross Validation Accuracy' in l:
				acc = l.split(' ')[-1].strip().strip('%')
				digit = "%5.2f"%float(acc)
				o.append(digit)	
			if 'Cross Validation Average SV' in l:
				sv = l.split(' ')[-1].strip().strip('%')
				digit = "%5.2f"%float(sv)
				o.append(digit)
	print "%s &  $%s$ & $%s\\%% $ & $%s\\%%$ & $%s$ & $%s\\%% $ & $%s\\%%$ \\\\"%(output_name[d],o[1],o[0],o[2],o[4],o[3],o[5])

for d in data:
	o = []
	for method in methodlist:
		dp = log_path + d + '.' + method + '.log'
		try:
			tmp_data = open(dp,'r').readlines()
		except:
			traindata = path + data_path[d]
			model = model_path + d + '.' + method + '.model'
			testdata = path + test_path[d]
			if method == "l1-loss":
				cmd = "%s -c %s -g %s -s 2 -t 2 -m 2048 -e %s %s %s >> %s"%(bsvm_train_exe, best_l1_c[d],best_l1_g[d],eps[d],traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
				cmd = "%s %s %s tmp_file >> %s; rm -f tmp_file"%(bsvm_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "l2-loss":
				cmd = "%s -c %s -g %s -s 4 -t 2 -m 2048 -e %s %s %s >> %s"%(bsvm_train_exe, best_l2_c[d],best_l2_g[d],eps[d],traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
				cmd = "%s %s %s tmp_file >> %s; rm -f tmp_file"%(bsvm_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			tmp_data = open(dp,'r').readlines()
		
		for l in tmp_data:
			if 'time:' in l:
				time = l.split(' ')[-1].strip()
				digit = FormatWithCommas("%5.2f",float(time))
				o.append(digit)
			if 'Accuracy' in l:
				acc = l.split(' ')[2].strip().strip('%')
				digit = "%5.2f"%float(acc)
				o.append(digit)	
			if 'Total nSV' in l:
				sv = l.split(' ')[-1].strip().strip('%')
				digit = "%5.2f"%float(sv)
				o.append(digit)
	print "%s & $%s$ & $%s\\%% $ & $%s\\%%$ & $%s$ & $%s\\%% $ & $%s\\%%$ \\\\"%(output_name[d],o[0],o[2],o[1],o[3],o[5],o[4])
print "\\multicolumn{7}{l}{*: $\\epsilon=0.1$ is used.}"
print "\\end{tabular}"
